from tkinter import *

class ConsoleFrame( Frame ):
  def __init__( self, parent, customfont ):
    Frame.__init__( self, parent )
    self.parent = parent
    self.customfont = customfont
    
    scrollbar = Scrollbar( self )
    self.text = Text( self, width=145, height=10, background="black", foreground="white", highlightthickness=0, state=DISABLED, yscrollcommand=scrollbar.set, font=self.customfont )
    scrollbar.config( command=self.text.yview )
    scrollbar.pack( side=RIGHT, fill=Y )
    self.text.pack( side=LEFT, fill=BOTH )
    self.text.tag_configure("green", foreground="green")
    self.text.tag_configure("red", foreground="red")
    self.text.tag_configure("orange", foreground="orange")
    self.text.tag_configure("yellow", foreground="yellow")
    self.text.tag_configure("lightblue", foreground="lightblue")

  def highlight_pattern( self, pattern, tag, start=1.0, end=END ):
    count = IntVar()
    while True:
      index = self.text.search( pattern, start, stopindex=end, count=count, regexp=False )
      if index == "" or index == None or index == "None":
        break
      else:
        self.text.tag_add( tag, index, "%s + %sc" % ( index, count.get() ) )
        start = index + "+1c"

  def log( self, string ):
    self.text.config( state=NORMAL )
    self.text.insert( END, string )
    self.text.see( END )
    self.highlight_pattern("PROPERTY PRESERVED", "green")
    self.highlight_pattern("PROPERTY NOT PRESERVED", "red")
    self.highlight_pattern("SEMANTICS PRESERVED", "green")
    self.highlight_pattern("SEMANTICS NOT PRESERVED", "red")
    self.highlight_pattern("UNDER FAIRNESS", "orange")
    self.highlight_pattern("WARNING!", "yellow")
    self.highlight_pattern("TRANSFORMATION FINISHED", "lightblue")
    self.text.config( state=DISABLED )
