from tkinter import *

class SyncFrame( Frame ):
  def __init__( self, frame, parent, customfont ):
    Frame.__init__( self, frame )
    self.parent = parent
    self.customfont = customfont
    
    left_frame = Frame( self )
    right_frame = Frame( self )
    left_frame.pack( side=LEFT )
    right_frame.pack( side=LEFT, padx=20 )

    existing_scrollbar = Scrollbar( left_frame )
    self.existing_rules_text = Text( left_frame, width=64, height=10, background="white", highlightbackground="black", highlightthickness=1, yscrollcommand=existing_scrollbar.set, font=self.customfont )
    self.existing_rules_label = Label( left_frame, text="Existing synchronisation laws:", font=self.customfont )
    existing_scrollbar.config( command=self.existing_rules_text.yview )

    new_scrollbar = Scrollbar( right_frame )
    self.new_rules_text = Text( right_frame, width=64, height=10, background="white", highlightbackground="black", highlightthickness=1, yscrollcommand=new_scrollbar.set, font=self.customfont )
    self.new_rules_label = Label( right_frame, text="New synchronisation laws:", font=self.customfont )
    new_scrollbar.config( command=self.new_rules_text.yview )

    self.existing_rules_label.grid( row=0, column=0, sticky=N+W )
    self.existing_rules_text.grid( row=1, column=0 )
    existing_scrollbar.grid( row=1, column=1, sticky=N+S )
    self.new_rules_label.grid( row=0, column=0, sticky=N+W )
    self.new_rules_text.grid( row=1, column=0 )
    new_scrollbar.grid( row=1, column=1, sticky=N+S )

  def get_rules( self ):
    return ( self.existing_rules_text.get( 1.0, END ), self.new_rules_text.get( 1.0, END ) )

  def update( self, existing_string, new_string):
    self.existing_rules_text.delete( 1.0, END )
    self.new_rules_text.delete( 1.0, END )
    self.existing_rules_text.insert( END, existing_string )
    self.new_rules_text.insert( END, new_string )
